#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=Stadion-Uhr.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Stadion-Uhr
#AutoIt3Wrapper_Res_Fileversion=1.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Timers.au3>
#include <Date.au3>

Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)

Global $sTitle = 'Stadion-Uhr v1.2    ' & Chr(169) & ' by Oscar (www.autoit.de)'

Global $sStatus = 'Start', $iTimer, $iTimerPause
Global $sDate = @MDAY & '.' & @MON & '.' & @YEAR
Global $iHalftime = 45 * 60 ; Standard-Spieldauer einer Halbzeit (in Sekunden)
Global $aGameTime[5] = [' 2 x 45 Minuten', ' 2 x 30 Minuten', ' 2 x 15 Minuten', ' 2 x 12 Minuten', ' 2 x 10 Minuten'] ; diese Zeiten stehen zur Auswahl

Global $iBkColor = 0x000000 ; Hintergrundfarbe
Global $iDateColor = 0xFFFFFF ; Farbe von aktueller Uhrzeit und Datum
Global $iLabelColor = 0x88AAFF ; Farbe der Beschriftung der Stopuhren
Global $iTimeActiveColor = 0xFFFF99 ; Farbe von Stopuhr aktiv
Global $iTimeInactiveColor = 0x999999 ; Farbe von Stopuhr inaktiv
Global $iAddActiveColor = 0xFF6666 ; Farbe von Nachspielzeit aktiv
Global $iAddInactiveColor = 0xFFAAAA ; Farbe von Nachspielzeit inaktiv

$hGui = GUICreate($sTitle, 640, 400, -1, -1, Default, 0x02000000)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor($iBkColor)
GUISetIcon('shell32.dll', 21)

$hTime = GUICtrlCreateLabel(@HOUR & ':' & @MIN & ':' & @SEC, 10, 10, 150, 35)
GUICtrlSetFont(-1, 22, 800, 0, 'Times New Roman')
GUICtrlSetColor(-1, $iDateColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hDate = GUICtrlCreateLabel($sDate, 480, 10, 150, 35, $SS_RIGHT)
GUICtrlSetFont(-1, 22, 800, 0, 'Times New Roman')
GUICtrlSetColor(-1, $iDateColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('1. Halbzeit', 10, 70, 200, 30, $SS_CENTER)
GUICtrlSetFont(-1, 20, 600, 0, 'Times New Roman')
GUICtrlSetColor(-1, $iLabelColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$h1stHalf = GUICtrlCreateLabel('00:00', 10, 100, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iTimeInactiveColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAddTime1 = GUICtrlCreateLabel('00:00', 10, 150, 200, 25, $SS_CENTER)
GUICtrlSetFont(-1, 16, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iAddActiveColor)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Pause', 215, 70, 200, 30, $SS_CENTER)
GUICtrlSetFont(-1, 20, 600, 0, 'Times New Roman')
GUICtrlSetColor(-1, $iLabelColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hPause = GUICtrlCreateLabel('00:00', 220, 100, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iTimeInactiveColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('2. Halbzeit', 430, 70, 200, 30, $SS_CENTER)
GUICtrlSetColor(-1, $iLabelColor)
GUICtrlSetFont(-1, 20, 600, 0, 'Times New Roman')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$h2ndHalf = GUICtrlCreateLabel('00:00', 430, 100, 200, 50, $SS_CENTER)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iTimeInactiveColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAddTime2 = GUICtrlCreateLabel('00:00', 430, 150, 200, 25, $SS_CENTER)
GUICtrlSetFont(-1, 16, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iAddActiveColor)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Gesamt-Spielzeit', 190, 190, 260, 30, $SS_CENTER)
GUICtrlSetColor(-1, $iLabelColor)
GUICtrlSetFont(-1, 20, 600, 0, 'Times New Roman')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hAll = GUICtrlCreateLabel('00:00', 190, 220, 260, 70, $SS_CENTER)
GUICtrlSetFont(-1, 48, 800, 0, 'Tahoma')
GUICtrlSetColor(-1, $iTimeInactiveColor)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Spielzeit-Auswahl:', 15, 330, 160, 20)
GUICtrlSetColor(-1, 0xEEEEEE)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
$hSelect = GUICtrlCreateCombo($aGameTime[0], 10, 353, 160, 30, $CBS_DROPDOWNLIST)
GUICtrlSetFont(-1, 16, 800, 0, 'Times New Roman')
GUICtrlSetOnEvent(-1, '_SelectGame')
For $i = 1 To UBound($aGameTime) -1
	GUICtrlSetData(-1, $aGameTime[$i])
Next

$hStart = GUICtrlCreateButton('Starte' & @CRLF & '1. Halbzeit', 205, 330, 235, 60, $BS_MULTILINE)
GUICtrlSetFont(-1, 16, 800, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_Startbutton')

GUICtrlCreateIcon(@ScriptDir & '\ball.ico', 1, 480, 180, 128, 128)
GUICtrlCreateIcon(@ScriptDir & '\shoes.ico', 1, 30, 180, 128, 128)

GUISetState()
GUIRegisterMsg($WM_TIMER, '_WM_TIMER')
$iDisplayTimer = _Timer_SetTimer($hGui, 200)

While Sleep(20)
WEnd

Func _End()
	If MsgBox(4 + 32 + 256, $sTitle, 'Programm wirklich beenden?') <> 6 Then Return
	_Timer_KillAllTimers($hGui)
	GUIDelete()
	Exit
EndFunc   ;==>_End

Func _SelectGame()
	$iHalftime = StringRegExpReplace(GUICtrlRead($hSelect), ' 2 x (\d+) Minuten', '$1') * 60
EndFunc

Func _Startbutton()
	Switch $sStatus
		Case 'Start'
			GUICtrlSetColor($h1stHalf, $iTimeActiveColor)
			GUICtrlSetColor($hAll, $iTimeActiveColor)
			$iTimer = _NowCalc()
			$sStatus = 'Pause'
			GUICtrlSetData($hStart, 'Halbzeit' & @CRLF & 'Pause')
			GUICtrlSetState($hSelect, $GUI_DISABLE)
		Case 'Pause'
			If _DateDiff('s', $iTimer, _NowCalc()) < $iHalftime Then
				If MsgBox(4 + 32 + 256, $sTitle, Int($iHalftime / 60) & ' Minuten sind noch nicht um!' & @CRLF & 'Wirklich auf "Pause" umschalten?') <> 6 Then Return
			EndIf
			GUICtrlSetColor($h1stHalf, $iTimeInactiveColor)
			GUICtrlSetColor($hAddTime1, $iAddInactiveColor)
			GUICtrlSetColor($hAll, $iTimeInactiveColor)
			GUICtrlSetColor($hPause, $iTimeActiveColor)
			$iTimerPause =  _NowCalc()
			GUICtrlSetData($hStart, 'Starte' & @CRLF & '2. Halbzeit')
			$sStatus = '2nd'
		Case '2nd'
			GUICtrlSetColor($h2ndHalf, $iTimeActiveColor)
			GUICtrlSetColor($hPause, $iTimeInactiveColor)
			GUICtrlSetColor($hAll, $iTimeActiveColor)
			GUICtrlSetData($hStart, 'Spiel' & @CRLF & 'beenden')
			$iTimer = _NowCalc()
			$sStatus = 'End'
		Case 'End'
			If _DateDiff('s', $iTimer, _NowCalc()) < $iHalftime Then
				If MsgBox(4 + 32 + 256, $sTitle, Int($iHalftime / 60) & ' Minuten sind noch nicht um!' & @CRLF & 'Wirklich auf "Ende" umschalten?') <> 6 Then Return
			EndIf
			GUICtrlSetColor($h1stHalf, $iTimeInactiveColor)
			GUICtrlSetColor($h2ndHalf, $iTimeInactiveColor)
			GUICtrlSetColor($hAddTime2, $iAddInactiveColor)
			GUICtrlSetColor($hAll, $iTimeInactiveColor)
			GUICtrlSetData($hStart, 'Anzeige' & @CRLF & 'zurcksetzen')
			$sStatus = 'Reset'
		Case 'Reset'
			GUICtrlSetState($hAddTime1, $GUI_HIDE)
			GUICtrlSetState($hAddTime2, $GUI_HIDE)
			GUICtrlSetColor($hAddTime1, $iAddActiveColor)
			GUICtrlSetColor($hAddTime2, $iAddActiveColor)
			GUICtrlSetData($h1stHalf, '00:00')
			GUICtrlSetData($h2ndHalf, '00:00')
			GUICtrlSetData($hPause, '00:00')
			GUICtrlSetData($hAll, '00:00')
			GUICtrlSetColor($hAll, $iTimeInactiveColor)
			GUICtrlSetData($hStart, 'Starte' & @CRLF & '1. Halbzeit')
			GUICtrlSetState($hSelect, $GUI_ENABLE)
			$sStatus = 'Start'
	EndSwitch
EndFunc   ;==>_Startbutton

Func _WM_TIMER($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $ilParam
	If _Timer_GetTimerID($iwParam) = $iDisplayTimer Then
		Local $iTmp
		Switch $sStatus
			Case 'Pause'
				$iTmp = _DateDiff('s', $iTimer, _NowCalc())
				GUICtrlSetData($h1stHalf, _SecsToTime($iTmp))
				GUICtrlSetData($hAll, _SecsToTime($iTmp))
				If $iTmp > $iHalftime Then
					GUICtrlSetState($hAddTime1, $GUI_SHOW)
					GUICtrlSetData($hAddTime1, _SecsToTime($iTmp - $iHalftime))
				EndIf
			Case '2nd'
				GUICtrlSetData($hPause, _SecsToTime(_DateDiff('s', $iTimerPause, _NowCalc())))
			Case 'End'
				$iTmp = _DateDiff('s', $iTimer, _NowCalc())
				GUICtrlSetData($h2ndHalf, _SecsToTime($iTmp))
				GUICtrlSetData($hAll, _SecsToTime($iTmp + $iHalftime))
				If $iTmp > $iHalftime Then
					GUICtrlSetState($hAddTime2, $GUI_SHOW)
					GUICtrlSetData($hAddTime2, _SecsToTime($iTmp - $iHalftime))
				EndIf
		EndSwitch
		GUICtrlSetData($hTime, @HOUR & ':' & @MIN & ':' & @SEC)
		If @MDAY & '.' & @MON & '.' & @YEAR <> $sDate Then
			$sDate = @MDAY & '.' & @MON & '.' & @YEAR
			GUICtrlSetData($hDate, $sDate)
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_TIMER

Func _SecsToTime($iSecs)
	Return StringFormat('%02i:%02i', Int($iSecs / 60), Mod($iSecs, 60))
EndFunc   ;==>_SecsToTime
